/*********************************************************************
 *
 *    *** HAPPy Pascal compiler ***
 *
 *      procedure or function call
 *        (ɕW葱W֐)
 *
 *     void call(Set fsys,ctp *fcp)
 *
 *        Copyright (c) H.Asano 1992.
 *
 **********************************************************************/

#define EXTERN extern
#include "pascomp.h"
#include "pcpcd.h"

/***********************************/
/* W葱W֐̎ʎq   */
/***********************************/
typedef enum stdpf
{
    /** W葱 **/
             spWRITE,                   /* write                      */
             spWRITELN,                 /* writeln                    */
             spREAD,                    /* read                       */
             spREADLN,                  /* readln                     */
             spPAGE,                    /* page                       */
             spGET,                     /* get                        */
             spPUT,                     /* put                        */
             spRESET,                   /* reset                      */
             spREWRITE,                 /* rewrite                    */
             spNEW,                     /* new                        */
             spDISPOSE,                 /* dispose                    */
             spPACK,                    /* pack                       */
             spUNPACK,                  /* unpack                     */
    /** W֐   **/
             sfABS,                     /* abs                        */
             sfSQR,                     /* sqr                        */
             sfTRUNC,                   /* trunc                      */
             sfROUND,                   /* round                      */
             sfODD,                     /* odd                        */
             sfORD,                     /* ord                        */
             sfCHR,                     /* chr                        */
             sfPRED,                    /* pred                       */
             sfSUCC,                    /* succ                       */
             sfEOLN,                    /* eoln                       */
             sfEOF,                     /* eof                        */
             sfSIN,                     /* sin                        */
             sfCOS,                     /* cos                        */
             sfEXP,                     /* exp                        */
             sfSQRT,                    /* sqrt                       */
             sfLN,                      /* ln                         */
             sfARCTAN,                  /* arctan                     */
} stdpf ;


/********** ֐̃vg^Cv錾 **********/

extern void calluser(Set,ctp*) ;
extern void expression(Set) ;
extern void selector(Set,ctp*) ;
extern ctp  *searchid(Set)  ;
extern Set  *mkset(Set*,int,...) ;
extern Set  *orset(Set*,Set*);
extern void enterid(ctp*)    ;
extern ctp  *mkctp(char*,enum idclass,stp*,ctp*) ;
extern void pcerr(int,char*) ;
extern void insymbol(void)   ;
extern boolean string(stp*)  ;
extern boolean compatible(stp*,stp*) ;
extern boolean assigncompati(stp*,stp*) ;
extern void checkbounds(stp*,int) ;
extern void getbounds(stp*,long*,long*) ;
extern void constant(Set, stp**, union valu*); 
extern int align(stp*,int) ;
extern void gen0(enum pcdmnc)     ;
extern void gen1(enum pcdmnc, int) ;
extern void gen0t(enum pcdmnc,stp*) ;
extern void gen1t(enum pcdmnc,stp*,int) ;
extern void gen2t(enum pcdmnc,stp*,int,int) ;
extern void gencsp(enum pcdprmnc) ;
extern void genldc(char,long) ;
extern void genlda(int,int)   ;
extern void genixa(long,int)  ;
extern void genchk(stp*,int,long,long) ;
extern void convertint(stp*)  ;
extern void load(void) ;
extern void loadaddress(void) ;
extern void store(attr) ;
extern void skip(Set) ;

static void pwrite(char*,Set,stdpf) ;
static void textwrite(Set,char*,attr)    ;
static void nottextwrite(Set,char*,attr) ;
static void pread(char*,Set,stdpf)  ;
static void nottextread(Set,char*,attr)  ;
static void ppage(char*,Set) ;
static void pgetputrstrwt(char*,Set,stdpf);
static void pnewdis(char*,Set,stdpf);
static void ppack(char*,Set) ;
static void punpack(char*,Set) ;
static void variable(Set)   ;
static void fabs(char*) ;
static void fsqr(char*) ;
static void ftrunc(char*) ;
static void fround(char*) ;
static void fodd(char*) ;
static void ford(char*) ;
static void fchr(char*) ;
static void fpredsucc(char*,stdpf) ;
static void feofeoln(char*,Set,stdpf)   ;
static void fcalc(char*,stdpf) ;
static void enterstdpf_sub(char*,enum idclass,stp*,stdpf) ;

/*********************************************************************/

/***************************************/
/*  call() : 葱֐̌ďo     */
/***************************************/
void call(Set fsys,ctp *fcp)
{
  int lkey ;
  char *name ;                          /* 葱(G[bZ[Wp)*/
  Set ws   ;

     if(fcp->n.pf.pfdeckind == standard) {  /* W葱orW֐̎ */
      lkey = fcp->n.pf.sd.key ;
      name = fcp->name        ;
      if(fcp->klass == proc) {          /* 葱̎                 */
       mkset(&ws,spWRITE,spWRITELN,spREAD,spREADLN,spPAGE,-1);
       if(! inset(ws,lkey))      /* write,writeln,read,readln,pageȊO*/
        if(sy == lparent) insymbol() ;
        else pcerr(9,"") ;              /* ( Ȃ                   */

       switch(lkey) {
        case spWRITE   :
        case spWRITELN :  pwrite(name,fsys,lkey) ;  break ;
        case spREAD    :
        case spREADLN  :  pread(name,fsys,lkey) ;   break ;
        case spPAGE    :  ppage(name,fsys) ;        break ;
        case spGET     :
        case spPUT     :
        case spRESET   :
        case spREWRITE :  pgetputrstrwt(name,fsys,lkey) ;  break ;
        case spNEW     :
        case spDISPOSE :  pnewdis(name,fsys,lkey) ;  break ;
        case spPACK    :  ppack(name,fsys) ;  break ;
        case spUNPACK  :  punpack(name,fsys) ; break ;
       }

       if(! inset(ws,lkey))      /* write,writeln,read,readln,pageȊO*/
        if(sy == rparent) insymbol() ;
        else pcerr(4,"") ;              /* ) Ȃ@                 */
      }

      else {                            /* W֐̎               */
       ws = fsys ;
       addset(ws,rparent) ;
       if((lkey != sfEOLN) && (lkey != sfEOF)) { /* eoln,eofȊO(*/
        if(sy == lparent) insymbol() ;
        else pcerr(9,"") ;              /* ( Ȃ                   */
        expression(ws)   ;              /* ̏                 */
        load()           ;              /* load                 */
       }

       switch(lkey) {                   /* ֐ɂU蕪       */
        case sfABS  : fabs(name)   ; break;
        case sfSQR  : fsqr(name)   ; break;
        case sfTRUNC: ftrunc(name) ; break;
        case sfROUND: fround(name) ; break;
        case sfODD  : fodd(name)   ; break;
        case sfORD  : ford(name)   ; break;
        case sfCHR  : fchr(name)   ; break;
        case sfPRED :
        case sfSUCC : fpredsucc(name,lkey)   ; break;
        case sfEOLN :
        case sfEOF  : feofeoln(name,ws,lkey) ; break;
        case sfSIN  :
        case sfCOS  :
        case sfEXP  :
        case sfSQRT :
        case sfLN   :
        case sfARCTAN: fcalc(name,lkey) ;break;  /* Zp֐          */
       } 

       if((lkey != sfEOLN) && (lkey != sfEOF))  /* eoln,eofȊO)*/
        if(sy == rparent) insymbol() ;
        else pcerr(4,"") ;              /* ) Ȃ                   */
        
      }
     }

     else calluser(fsys,fcp) ;          /* [U`̎葱֐Ă*/
}

/*****************************************/
/* cspfile():t@Co͊֌W̖ߐ*/
/*****************************************/
static void cspfile(attr fattr,enum pcdprmnc mnc)
{
     if(fattr.access == drct)           /* t@Cϐϐ̎   */ 
      genlda(level-fattr.vlevel, fattr.dplmt);
     else                              /* t@Cϐϐ      */ 
      gen2t(iLOD,nilptr,level-fattr.vlevel,fattr.dplmt) ;
     gencsp(mnc) ;                     /* cspߐ                 */
}

/***************************************/
/* pwrite() : write/writeln葱̏*/
/***************************************/
void pwrite(char *name,Set fsys,stdpf fkey)
{
  stp *lsp ;
  attr fileattr ;
  boolean test ;
  boolean textflag;
  Set ws,ws1 ;

     fileattr.access = drct ;
     fileattr.vlevel = 1 ;              /* t@Cϐȗ       */
     fileattr.dplmt  = outputadr ;      /* outputt@C蓖Ă */
     textflag = true    ;
     mkset(&ws,comma,colon,rparent,-1) ;
     orset(&ws,&fsys) ;

     if(sy == lparent) {                /* (        */
      insymbol() ;
      expression(ws) ;                  /* ŏ̎                   */
      lsp = gattr.typtr ;
      test = false ; 
      if(lsp)
       if(lsp->form == files) {         /***** t@Cϐ̏ *****/
        fileattr = gattr ;              /* t@Cϐ̑ޔ   */
        if(fileattr.access == indrct)   /* ϐ           */
         gen2t(iSTR,nilptr,level-fileattr.vlevel,fileattr.dplmt) ;
       /* łlodaĂ܂Ă̂ŃX^bN|C^߂*/
        if(!lsp->sf.fi.texttype) {      /*eLXgt@CłȂ      */
         textflag = false ;
         if(fkey == spWRITELN) pcerr(116,name) ;/* writeln̓eLXĝ*/
        }
        if(sy == rparent) {
         if(fkey == spWRITE) pcerr(116,name) ; /* write̎)͑ʖ  */
         test = true ;                  /* I                 */
        }
        else if(sy == comma) {          /* t@CϐɎ , */
         insymbol() ; 
         expression(ws) ;               /* o͑Ώێ                 */
        }
        else {                          /* ) , ȊO                   */
         pcerr(116,name);               /* W葱̈Ɍ     */
         mkset(&ws1,comma,rparent);
         orset(&ws1,&fsys);
         skip(ws1) ;                    /* ǂݔ΂                 */
        }
       }
       else if(!defineoutput) pcerr(301,name) ; /* t@Cϐȗ
                                                  output`ȂG[*/

      if(! test)
       if(textflag) 
        textwrite(ws,name,fileattr);        /*  o͑Ώێ̏      */
       else 
        nottextwrite(fsys,name,fileattr);   /* eLXgȊOւ̏o   */

      if(sy == rparent) insymbol() ;
      else pcerr(4,"") ;
     }

     else                               /* (Ȃ  Ȃ     */
      if(fkey == spWRITE) pcerr(116,name) ;   /* write͕KKv*/
      else if(!defineoutput) pcerr(301,name) ;/* output`͑ʖ   */

     if(fkey == spWRITELN)
      cspfile(fileattr,pWLN) ;
}

/***************************************/
/* textwrite() : text^ւ̏o        */
/***************************************/
static void textwrite(Set fsys,char *fname,attr fattr)
{
  stp *lsp;
  int len ;
  boolean defaultcolum  ;               /* default ̎ true      */
  boolean test          ;
  Set ws                ;

     do {
      defaultcolum = true ;

      lsp = gattr.typtr ;
      if(lsp)
       (lsp->form <= subrange) ? load() : loadaddress() ;

       if(sy==colon) {                  /* w肪鎞           */
        insymbol() ;                    /* ǂ                 */
        expression(fsys) ;              /* ̏                 */
        if(gattr.typtr)
         if(gattr.typtr != intptr)
          pcerr(116,fname) ;            /* W葱̈̌^   */
         load() ;                       /* load                 */
         defaultcolum = false ;         /* w肠               */
       }

       if(lsp == intptr) {              /* ^                     */
        if(defaultcolum) genldc('i',12L); /* ȗ  12         */
        cspfile(fattr,pWRI) ;
       }
       else if(lsp == realptr) {        /* ^                     */
        if(sy!=colon) {                 /* Œ菭_włȂ     */
         if(defaultcolum) genldc('i',14L) ; /* ȗ 14        */
          cspfile(fattr,pWRR) ;         /* csp wrr  (_o)  */
        }
        else {                          /* Œ菬_o             */
         insymbol() ;                   /* ǂ                 */
         expression(fsys) ;             /* ̏                 */
         if(gattr.typtr)
          if(gattr.typtr != intptr)
           pcerr(116,fname) ;           /* W葱̈̌^   */
         load() ;                       /* load                 */
         cspfile(fattr,pWRF) ;          /* csp wrf  (Œ菭_o)  */
        }
       }
       else if(lsp == charptr) {        /* ^                     */
        if(defaultcolum) genldc('i',(long)1);   /* ȗ 1     */
        cspfile(fattr,pWRC) ;
       }
       else if(string(lsp)) {           /* ^                   */
        len = lsp->size / charmax ;
        if(defaultcolum) genldc('i',(long)len); /* ȗ ̌*/
        genldc('i',(long)len) ;
        cspfile(fattr,pWRS) ;
       }
       else if(lsp == boolptr) {        /* boolean^                  */
        if(defaultcolum) genldc('i',(long)5) ; /* ȗ  5     */
        cspfile(fattr,pWRB) ;
       }
       else pcerr(116,fname) ;          /* W֐̈̌^̌   */

       if(test = (sy == comma)) {
       insymbol() ;
       expression(fsys) ;               /* ̏o͑Ώێ             */
      }
     } while(test) ;                    /* , ȂJԂ             */
}

/*****************************************/
/* nottextwrite() : eLXg^ȊȌo */
/*****************************************/
static void nottextwrite(Set fsys,char *fname,attr fattr)
{
  attr bufattr ;                        /* obt@ϐ̑         */
  boolean test ;
  Set ws ;

     bufattr.typtr = fattr.typtr->sf.fi.filtype ; /* obt@ϐ̌^ */
     bufattr.kind    = varbl ;
     bufattr.access  = drct  ;
     bufattr.vlevel  = fattr.vlevel ;
     bufattr.dplmt   = fattr.dplmt  ;
     mkset(&ws,comma,rparent,-1);
     orset(&ws,&fsys) ;

     do {
      if(gattr.typtr)
       if(gattr.typtr->form <= power)   /* XJ[͈ͤ|C^W*/
        load() ;
       else loadaddress() ;

      if(gattr.typtr) {
       if((bufattr.typtr == realptr) &&        /* obt@ϐreal    */
          (compatible(gattr.typtr,intptr))) {  /* ̂^̎  */
        gen0(iFLT) ;                           /* ɕϊ flt    */
        gattr.typtr = realptr ;
       }

       if(assigncompati(bufattr.typtr,gattr.typtr)) /* ޯ̧ϐɑ\ */
        switch(bufattr.typtr->form) {   /* ^ɂĐU蕪       */
         case scalar   :
         case subrange :
           checkbounds(bufattr.typtr,18) ; /* ̃`FbN     */ 
           store(bufattr) ;
           break ;
         case pointer  :
           store(bufattr) ;
           break ;
         case power :
           checkbounds(bufattr.typtr,72) ; /* ̃`FbN     */
           store(bufattr) ;
           break ;
         case arrays  :
         case records :
           gen2t(iMOV,nil,1,bufattr.typtr->size) ;
           break ;
         case files :
           pcerr(116,fname) ;           /* W葱̈       */
        }
       else pcerr(116,fname) ;          /* \łȂꍇ         */

       cspfile(fattr,pPUT) ;            /* csp put                    */
      }

      if(test = (sy == comma)) {
       insymbol() ;
       expression(ws) ;               /* ̏o͑Ώێ               */
      }
     } while(test) ;                  /* , ȂJԂ               */
}

/***************************************/
/* pread() : read/readln葱̏   */
/***************************************/
static void pread(char* name,Set fsys,stdpf fkey)
{
  stp *lsp ;
  attr fileattr ;
  boolean textflag ;
  boolean test ;
  Set ws ;

     fileattr.access = drct ;
     fileattr.vlevel = 1 ;              /* t@Cϐȗ       */
     fileattr.dplmt  = inputadr ;       /* inputt@C蓖Ă  */
     textflag = true   ;
     mkset(&ws,comma,rparent,-1) ;
     orset(&ws,&fsys) ;

     if(sy == lparent) {                /* (        */
      insymbol() ;
      variable(ws) ;                    /* ŏ̕ϐ                 */
      lsp = gattr.typtr;
      test = false ;
      if(lsp)
       if(lsp->form == files) {         /****** file ϐ̏ *******/
        fileattr = gattr ;              /* t@Cϐ̑ޔ   */
        if(fileattr.access == indrct)   /* ϐ           */
         gen2t(iSTR,nilptr,level-fileattr.vlevel,fileattr.dplmt) ;
       /* łlodaĂ܂Ă̂ŃX^bN|C^߂*/
        if(!lsp->sf.fi.texttype)  {     /* textt@CȊO           */
         textflag = false ;
         if(fkey == spREADLN) pcerr(116,name) ;/* readln̓eLXĝ*/
        }
        if(sy == rparent) {
         if(fkey == spREAD) pcerr(116,name) ; /* read̎)͑ʖ    */
         test = true ;                  /* I                 */
        } 
        else if(sy != comma) {          /* t@CϐɎ,łȂ*/
         pcerr(116,name);               /* W葱̈Ɍ     */
         skip(ws) ;                     /* ǂݔ΂                 */
        }
        if(sy == comma) {
         insymbol() ;
         variable(ws) ;                 /* ,ɑϐ̏          */
        }
        else test = true ;              /* ) ̎                     */
       }
       else if(!defineinput) pcerr(300,name) ; /* t@Cϐȗ
                                               Input`ȂG[*/

      if(! test)                        /**** ǍΏەϐ̏ ******/
       if(textflag)                     /* eLXgt@C̎       */
        do {
         loadaddress() ;
 
         if(gattr.typtr)
          if(gattr.typtr->form <= subrange) 
           if(compatible(intptr,gattr.typtr))
            cspfile(fileattr,pRDI) ;    /* integer^Ȃ csp rdi      */
           else if(realptr == gattr.typtr)
            cspfile(fileattr,pRDR) ;    /*  real^Ȃ    csp rdr     */
           else if(compatible(charptr,gattr.typtr))
            cspfile(fileattr,pRDC) ;    /*  char^Ȃ    csp rdc     */
           else pcerr(116,name) ;       /* ̌^Ɍ             */
          else  pcerr(116,name) ;       /* ̌^Ɍ             */
           
          if(test = (sy == comma)) {
          insymbol() ;
          variable(ws) ;                /* ̕ϐ̏             */
          }
        } while(test) ;
       else nottextread(fsys,name,fileattr); /* eLXgȊO̓    */ 

      if(sy == rparent) insymbol() ;
      else pcerr(4,"") ;
     }
     else
      if(fkey == spREAD)    pcerr(116,name) ;
      else if(!defineinput) pcerr(300,name) ; /* readlnňȂ
                                                  input`͑ʖ   */

     if(fkey == spREADLN)               /* readln֐̎             */
      cspfile(fileattr,pRLN) ;          /*  csp rln                   */
}

/*****************************************/
/* nottextread() : eLXg^ȊO̓  */
/*****************************************/
static void nottextread(Set fsys,char *fname,attr fattr)
{
  attr bufattr ;                        /* obt@ϐ̑         */
  attr lattr   ;                        /* ޔp                     */
  boolean test ;
  Set ws ;

     bufattr.typtr = fattr.typtr->sf.fi.filtype ; /* obt@ϐ̌^ */
     bufattr.kind    = varbl ;
     bufattr.access  = drct  ;
     bufattr.vlevel  = fattr.vlevel ;
     bufattr.dplmt   = fattr.dplmt  ;
     mkset(&ws,comma,rparent,-1);
     orset(&ws,&fsys) ;

     do {
      if(gattr.typtr) 
       if((gattr.access != drct) ||     /* ڎQƂłȂ            */
          (gattr.typtr->form > power))  /* z^R[h^t@C^*/
        loadaddress() ;                 /* ̎́AAhX̂   */
      lattr = gattr ;
      gattr = bufattr ;                 /*  obt@ϐ̃[h      */
      if(gattr.typtr)
       if(gattr.typtr->form <= power)   /* XJ[͈ͤ|C^W*/
        load() ;
       else loadaddress() ;             /* z񤃌R[hloadaddress */
      gattr = lattr   ;
      if(gattr.typtr) {
       if((gattr.typtr == realptr) &&          /* ǂޕϐreal      */
          (compatible(bufattr.typtr,intptr))){ /* ޯ̧ϐ^ */
        gen0(iFLT) ;                           /* ɕϊ flt  */
        gattr.typtr = realptr ;
       }

       if(assigncompati(gattr.typtr,bufattr.typtr)) /* \   */
        switch(gattr.typtr->form) {     /* ^ɂĐU蕪       */
         case scalar   :
         case subrange :
           checkbounds(gattr.typtr,17) ;/* ̃`FbN        */ 
           store(gattr) ;
           break ;
         case pointer  :
           store(gattr) ;
           break ;
         case power :
           checkbounds(lattr.typtr,71) ;/* ̃`FbN        */
           store(gattr) ;
           break ;
         case arrays  :
         case records :
           gen2t(iMOV,nil,1,gattr.typtr->size) ;
           break ;
         case files :
           pcerr(116,fname) ;           /* W葱̈       */
        }
       else pcerr(116,fname) ;          /* \łȂꍇ         */

       cspfile(fattr,pGET)  ;           /* csp get                    */
      }

      if(test = (sy == comma)) {
       genlda(level-bufattr.vlevel,bufattr.dplmt) ; /* ޯ̧ϐڽ */
       insymbol() ;
       variable(ws) ;                 /* ̏o͑Ώێ               */
      }
     } while(test) ;                  /* , ȂJԂ               */
}

/***************************************/
/* ppage() : page葱̏          */
/***************************************/
static void ppage(char* name,Set fsys)
{
  Set  ws    ;

     ws = fsys ;
     addset(ws,rparent) ;

     if(sy == lparent)  {               /* 鎞               */
      insymbol()   ;
      variable(ws) ;                    /* t@Cϐ               */
      loadaddress() ;
      if(gattr.typtr != textptr)        /* eLXgt@CłȂ */
       pcerr(116,name) ;                /* W葱̈       */
      if(sy == rparent) insymbol() ;
      else pcerr(4,"") ;                /* )Ȃ                    */
     }
     else {                             /* Ȃ               */
      if(!defineoutput) pcerr(116,name);/* outputt@C`       */
      genlda(level-1,outputadr) ;       /* outputAhX             */
     }

     gencsp(pPGE) ;                     /* csp pge                    */
}

/***********************************************************/
/* pgetputrstrwt() : get/put/reset/rewrite葱̏     */
/***********************************************************/
static void pgetputrstrwt(char *name,Set fsys,stdpf fkey)
{
  enum pcdprmnc cspname ;               /* csp߂̃Iyh        */
  Set ws ;

     ws = fsys ;
     addset(ws,rparent) ;
     variable(ws) ;                     /* t@Cϐ               */
     loadaddress() ;

     if(gattr.typtr)
      if(gattr.typtr->form != files)    /* t@CϐłȂ         */
       pcerr(116,name) ;                /* W葱̈       */
      else {
       if(gattr.typtr == textptr)       /* eLXgt@C̎       */
        switch(fkey) {
         case spGET    : cspname = pTGT ; break ;
         case spPUT    : cspname = pTPT ; break ;
         case spRESET  : cspname = pTRS ; break ;
         case spREWRITE: cspname = pTRW ; break ;
        }
       else                             /* eLXgt@CȊO̎   */  
        switch(fkey) {
         case spGET    : cspname = pGET ; break ;
         case spPUT    : cspname = pPUT ; break ;
         case spRESET  : cspname = pRST ; break ;
         case spREWRITE: cspname = pRWT ; break ;
        }
       gencsp(cspname) ;                /* csp߂̐              */  
      }
}

/***************************************/
/* pnewdis() : new/dispose葱̏ */
/***************************************/
static void pnewdis(char *name,Set fsys,stdpf fkey)
{
  stp *lsp = nil;
  stp *lsp1     ;
  stp *lspconst ;                       /* 萔̌^                   */
  union valu lval ;                     /* 萔̒l                   */
  int lsize = 0 ;                       /* mۥGATCY  */
  Set ws ;

     mkset(&ws,rparent,comma,-1);
     orset(&ws,&fsys) ;
     if(fkey == spNEW) {
      variable(ws)  ;                   /* new͈ϐ̏        */
      loadaddress() ;
     } 
     else {
      expression(ws);                   /* dispose͎@    */
      load() ;
     } 

     if(gattr.typtr)
      if(gattr.typtr->form == pointer) {
       if(gattr.typtr->sf.pt.eltype) {  /* w̌^       */
        lsize = gattr.typtr->sf.pt.eltype->size ;
        if(gattr.typtr->sf.pt.eltype->form == records)
         lsp = gattr.typtr->sf.pt.eltype->sf.re.recvar ; /* ϕ    */
       }
      }
      else pcerr(116,name) ;            /* W葱̈̌^Ɍ */

     while(sy == comma) {               /* 萔̎w肪鎞         */
      insymbol() ;
      constant(ws,&lspconst,&lval)  ;
      if(string(lspconst) || (lspconst==realptr)) /* ^    */
       pcerr(159,"") ;                  /* ^͎ws    */
      if(!lsp) pcerr(162,"")  ;        /* YϗvfIqȂ*/
      else if((lsp->form == tagfld) &&
              (lsp->sf.tg.tagtype)) {   /* ϕꍇ           */
       if(compatible(lsp->sf.tg.tagtype,lspconst)) { /* ^K  */
        if(lsp->sf.tg.tagtype->form == subrange)
         if((lval.ival < lsp->sf.tg.tagtype->sf.su.min) ||
            (lval.ival > lsp->sf.tg.tagtype->sf.su.max))  /* ͈͊O   */
          pcerr(162,"") ;              /* YϗvfIqȂ*/
        lsp1 = lsp->sf.tg.fstvar ;
        while(lsp1) {                   /* YϗvfT     */
         if(lsp1->sf.vr.varval == lval.ival) {  /* Kv̂*/
          lsize = lsp1->size ;
          break ;
         }
         else lsp1 = lsp1->sf.vr.nextvr ;
        }
       }
       else pcerr(162,"") ;             /* YϗvfIqȂ*/
       lsp   = lsp1->sf.vr.subvar ;     /* z̉ϕ               */
      }
      else pcerr(162,"") ;              /* YϗvfIqȂ*/
     }

     genldc('i',(long)lsize) ;          /* ldc߂Ŋmےload      */
     if(fkey == spNEW) gencsp(pNEW) ;   /* csp new                    */
     else              gencsp(pDIS) ;   /* csp dis                    */
}

/***************************************/
/*     ppack() : pack葱̏      */
/***************************************/
static void ppack(char *name,Set fsys)
{
  stp *lspuinx=nil;                      /* l߂Ȃz̓Y̌^   */
  stp *lspuael=nil;                      /* l߂Ȃz̗vf̌^     */
  long lmin,lmax  ;
  int  lsize      ;
  Set ws ;

     mkset(&ws,comma,rparent,-1);
     orset(&ws,&fsys);
     variable(ws) ;                     /* l߂Ȃz               */
     if(gattr.typtr)
      if((gattr.typtr->form == arrays)  /* l߂Ȃz`FbN       */
      && (!gattr.typtr->sf.ar.packed)) {
       lspuinx = gattr.typtr->sf.ar.inxtype;
       lspuael = gattr.typtr->sf.ar.aeltype;
       loadaddress() ;                  /* ]AhX[h     */
      }
      else pcerr(116,name) ;            /* W葱̈̌^ */
     if(sy == comma) insymbol() ;

     expression(ws) ;                   /* l߂Ȃz̓Y     */
     if(gattr.typtr)
      if((gattr.typtr->form  == scalar)
      && (compatible(gattr.typtr,lspuinx))) { /* ^K邱     */
       load() ;                         /* ̒l[h             */
       convertint(gattr.typtr) ;        /* KvȂordߐ        */
       getbounds(lspuinx,&lmin,&lmax) ; /* Y͈̔͂𒲂ׂ       */
       if(debug) genchk(intptr,26,lmin,lmax) ; /* chk߂𐶐       */
       lsize = lspuael->size ;
       lsize = align(lspuael,lsize) ;   /* E킹                 */
       genixa(lmin,lsize) ;             /* ixaߐ                */
      }
      else pcerr(116,name) ;            /* W葱̈̌^ */
     if(sy == comma) insymbol() ;

     ws = fsys;
     addset(ws,rparent) ;
     variable(ws) ;                     /* lߍݔz               */
     if(gattr.typtr)
      if((gattr.typtr->form == arrays)  /* lߍݔz`FbN       */
      && (gattr.typtr->sf.ar.packed)
      && (compatible(gattr.typtr->sf.ar.inxtype,lspuinx))
      && (compatible(gattr.typtr->sf.ar.aeltype,lspuael))) {
       loadaddress() ;                  /* ]AhX[h     */
       gen2t(iMOV,nil,2,gattr.typtr->size) ; /* mov 2             */
      } 
      else pcerr(116,name) ;            /* W葱̈̌^ */
}

/***************************************/
/*     punpack() : unpack葱̏  */
/***************************************/
static void punpack(char *name,Set fsys)
{
  stp *lsppinx=nil;                     /* l߂z̓Y̌^   */
  stp *lsppael=nil;                     /* l߂z̗vf̌^     */
  stp *lspuinx=nil;                     /* l߂Ȃz̓Y̌^   */
  stp *lspuael=nil;                     /* l߂Ȃz̗vf̌^     */
  long lmin,lmax  ;
  int  lsize      ;
  int  movleng    ;                     /* ]                     */
  Set ws ;

     mkset(&ws,comma,rparent,-1);
     orset(&ws,&fsys);
     variable(ws) ;                     /* l߂z               */
     if(gattr.typtr)
      if((gattr.typtr->form == arrays)  /* l߂z`FbN       */
      && (gattr.typtr->sf.ar.packed)) {
       lsppinx = gattr.typtr->sf.ar.inxtype;
       lsppael = gattr.typtr->sf.ar.aeltype;
       movleng = gattr.typtr->size ;
       loadaddress() ;                  /* ]AhX[h     */
      }
      else pcerr(116,name) ;            /* W葱̈̌^ */
     if(sy == comma) insymbol() ;

     variable(ws) ;                     /* l߂Ȃz               */
     if(gattr.typtr)
      if((gattr.typtr->form == arrays)  /* l߂Ȃz`FbN       */
      && (!gattr.typtr->sf.ar.packed)
      && (compatible(gattr.typtr->sf.ar.inxtype,lsppinx))
      && (compatible(gattr.typtr->sf.ar.aeltype,lsppael))) {
       lspuinx = gattr.typtr->sf.ar.inxtype;
       lspuael = gattr.typtr->sf.ar.aeltype;
       loadaddress() ;                  /* AhX[h       */
      } 
      else pcerr(116,name) ;            /* W葱̈̌^ */
     if(sy == comma) insymbol() ;

     ws = fsys;
     addset(ws,rparent) ;
     expression(ws) ;                   /* l߂Ȃz̓Y     */
     if(gattr.typtr)
      if((gattr.typtr->form  == scalar)
      && (compatible(gattr.typtr,lspuinx))) { /* ^K邱     */
       load() ;                         /* ̒l[h             */    
       convertint(gattr.typtr) ;        /* KvȂordߐ        */
       getbounds(lspuinx,&lmin,&lmax) ; /* Y͈̔͂𒲂ׂ       */
       if(debug) {
        genchk(intptr,29,lmin,lmax) ;   /* chk߂𐶐              */
        genldc('i',(long)(movleng-1));  /* ]-1                   */
        gen0(iADI) ;                    /* ]̔zY         */
        genchk(intptr,31,lmin,lmax) ;   /* Y͈͓             */
        genldc('i',(long)(movleng-1));
        gen0(iSBI) ;                    /* Ƃɖ߂                 */
       } 
       lsize = lsppael->size ;
       lsize = align(lsppael,lsize) ;   /* E킹                 */
       genixa(lmin,lsize) ;             /* ixaߐ                */
       gen2t(iMOV,nil,2,movleng) ;      /* mov 2                  */
      } 
      else pcerr(116,name) ;            /* W葱̈̌^ */
}

/***************************************/
/*     fabs() : abs֐̏          */
/***************************************/
static void fabs(char *name)
{
     if(gattr.typtr)
      if(gattr.typtr == intptr)       gen0(iABI) ;  /* integerȂabi */
      else if(gattr.typtr == realptr) gen0(iABR) ;  /* real   Ȃabr */
      else {
       pcerr(125,name) ;                /* W֐̈̌^Ɍ   */
       gattr.typtr = intptr ;
      }
}

/***************************************/
/*     fsqr() : sqr֐̏          */
/***************************************/
static void fsqr(char *name)
{
     if(gattr.typtr)
      if(gattr.typtr == intptr)       gen0(iSQI) ;  /* integerȂsqi */
      else if(gattr.typtr == realptr) gen0(iSQR) ;  /* real   Ȃsqr */
      else {
       pcerr(125,name) ;                /* W֐̈̌^Ɍ   */
       gattr.typtr = intptr ;
      }
}

/***************************************/
/*    ftrunc() : trunc֐̏       */
/***************************************/
static void ftrunc(char *name)
{
     if(gattr.typtr)
      if(gattr.typtr == realptr) gen0(iTRC) ; /* real Ȃtrc         */
      else pcerr(125,name) ;            /* W֐̈̌^Ɍ   */
     gattr.typtr = intptr ;
}

/***************************************/
/*    fround() : round֐̏       */
/***************************************/
static void fround(char *name)
{
     if(gattr.typtr)
      if(gattr.typtr == realptr) gen0(iROU) ; /* real Ȃrou         */
      else pcerr(125,name) ;            /* W֐̈̌^Ɍ   */
     gattr.typtr = intptr ;
}

/***************************************/
/*     fodd() : odd֐̏          */
/***************************************/
static void fodd(char *name)
{
     if(gattr.typtr)
      if(gattr.typtr == intptr) gen0(iODD) ; /* integerȂodd        */
      else pcerr(125,name) ;            /* W֐̈̌^Ɍ   */
     gattr.typtr = boolptr ;
}
     
/***************************************/
/*     ford() : ord֐̏          */
/***************************************/
static void ford(char *name)
{
     if(gattr.typtr)
      if((gattr.typtr->form <= subrange) /* XJA͈͌^         */
      && (gattr.typtr != realptr))       /* realłȂ               */ 
       convertint(gattr.typtr) ;         /* KvȂord߂𐶐    */
      else pcerr(125,name) ;             /* W֐̈̌^Ɍ   */
     gattr.typtr = intptr ;
}

/***************************************/
/*     fchr() : chr֐̏          */
/***************************************/
static void fchr(char *name)
{
     if(gattr.typtr)
      if(gattr.typtr == intptr) gen0(iCHR) ; /* integerȂ chr   */
      else pcerr(125,name) ;            /* W֐̈̌^Ɍ   */
     gattr.typtr = charptr ;
}

/***************************************/
/* fpredsucc() : pred / succ֐̏ */
/***************************************/
static void fpredsucc(char *name,stdpf fkey)
{
     if(gattr.typtr)
      if(gattr.typtr->form == scalar)   /* ̓XĴ         */
       if(fkey == sfSUCC) gen1t(iINC,gattr.typtr,1) ; /* succȂinc  */
       else               gen1t(iDEC,gattr.typtr,1) ; /* predȂdec  */
      else pcerr(125,name) ;            /* W֐̈̌^Ɍ   */
}

/***************************************/
/* feofeoln() : eof,eoln֐̏     */
/***************************************/
static void feofeoln(char *name,Set fsys,stdpf fkey)
{
     if(sy == lparent) {                /* 鎞               */
      insymbol()   ;          
      variable(fsys) ;                  /* t@Cϐ̏         */
      if(sy == rparent) insymbol() ;
      else pcerr(4,"") ;                /* ) Ȃ                   */
     }
     else {                             /* Ȃ               */
      if(!defineinput) pcerr(300,name); /*  input`̎͑ʖ     */
      gattr.typtr = textptr ;
      gattr.kind  = varbl   ;
      gattr.access = drct ;
      gattr.vlevel = 1      ;
      gattr.dplmt  = inputadr ;
     }

     loadaddress() ;                    /* obt@AhXload     */
     
     if(gattr.typtr)
      if((gattr.typtr->form != files) ||/* ̌^file^łȂ     */
         ((fkey==sfEOLN) && (gattr.typtr!=textptr)))
                                        /* eoln̎text^ʖ   */
       pcerr(125,name) ;                /* W֐̈̌^Ɍ   */

     (fkey == sfEOLN) ? gencsp(pEOL) : gencsp(pEOF) ; /* csp eol/ csp/eof*/

     gattr.typtr = boolptr ;
}

/***************************************/
/* fcalc(): Zp֐̏             */
/***************************************/
static void fcalc(char *name,stdpf fkey)
{
  enum pcdprmnc lmnc;                   /* csp߂̃Iyh        */
  
     if(gattr.typtr) {
      if(gattr.typtr == intptr) {       /* integer              */
       gen0(iFLT) ;                     /* realɕϊ           */
       gattr.typtr = realptr ;
      }
      else if(gattr.typtr != realptr)
       pcerr(125,name) ;                /* W֐̈̌^Ɍ   */
      switch(fkey) {
       case sfSIN    : lmnc = pSIN; break;
       case sfCOS    : lmnc = pCOS; break;
       case sfEXP    : lmnc = pEXP; break;
       case sfSQRT   : lmnc = pSQT; break;
       case sfLN     : lmnc = pLOG; break;
       case sfARCTAN : lmnc = pATN; break;
      }
      gencsp(lmnc) ;
     }
}

/***************************************/
/* variable() : ϐ̏         */
/***************************************/
static void variable(Set fsys)
{
  ctp *lcp ;
  Set ws;

     if(sy == ident) {                  /* O̎             */
      mkset(&ws,vars,field,-1);
      lcp = searchid(ws) ;              /* ϐtB[hT  */
      insymbol() ;
     }
     else {
      pcerr(2,"") ;                     /* OȂ                 */
      lcp = uvarptr ;                   /* `ϐp̖OGA   */
     }
     selector(fsys,lcp) ;
}

/*****************************************/
/* enterstdf() : W葱֐̓o^ */
/*****************************************/
void enterstdpf(void)
{
     enterstdpf_sub("write"   ,proc,nilptr,spWRITE)   ;  /* write     */
     enterstdpf_sub("writeln" ,proc,nilptr,spWRITELN) ;  /* writeln   */
     enterstdpf_sub("read"    ,proc,nilptr,spREAD)    ;  /* read      */
     enterstdpf_sub("readln"  ,proc,nilptr,spREADLN)  ;  /* readln    */
     enterstdpf_sub("page"    ,proc,nilptr,spPAGE)    ;  /* page      */
     enterstdpf_sub("get"     ,proc,nilptr,spGET)     ;  /* get       */
     enterstdpf_sub("put"     ,proc,nilptr,spPUT)     ;  /* put       */
     enterstdpf_sub("reset"   ,proc,nilptr,spRESET)   ;  /* reset     */
     enterstdpf_sub("rewrite" ,proc,nilptr,spREWRITE) ;  /* rewrite   */
     enterstdpf_sub("new"     ,proc,nilptr,spNEW)     ;  /* new       */
     enterstdpf_sub("dispose" ,proc,nilptr,spDISPOSE) ;  /* dispose   */
     enterstdpf_sub("pack"    ,proc,nilptr,spPACK)    ;  /* pack      */
     enterstdpf_sub("unpack"  ,proc,nilptr,spUNPACK)  ;  /* unpack    */

     enterstdpf_sub("abs"     ,func,nilptr ,sfABS)    ;  /* abs       */
     enterstdpf_sub("sqr"     ,func,nilptr ,sfSQR)    ;  /* sqr       */
     enterstdpf_sub("trunc"   ,func,intptr ,sfTRUNC)  ;  /* trunc     */
     enterstdpf_sub("round"   ,func,intptr ,sfROUND)  ;  /* round     */
     enterstdpf_sub("odd"     ,func,boolptr,sfODD)    ;  /* odd       */
     enterstdpf_sub("ord"     ,func,intptr ,sfORD)    ;  /* ord       */
     enterstdpf_sub("chr"     ,func,charptr,sfCHR)    ;  /* chr       */
     enterstdpf_sub("pred"    ,func,nilptr ,sfPRED)   ;  /* pred      */
     enterstdpf_sub("succ"    ,func,nilptr ,sfSUCC)   ;  /* succ      */
     enterstdpf_sub("eoln"    ,func,boolptr,sfEOLN)   ;  /* eoln      */
     enterstdpf_sub("eof"     ,func,boolptr,sfEOF)    ;  /* eof       */
     enterstdpf_sub("sin"     ,func,realptr,sfSIN)    ;  /* sin       */
     enterstdpf_sub("cos"     ,func,realptr,sfCOS)    ;  /* cos       */
     enterstdpf_sub("exp"     ,func,realptr,sfEXP)    ;  /* exp       */
     enterstdpf_sub("sqrt"    ,func,realptr,sfSQRT)   ;  /* sqrt      */
     enterstdpf_sub("ln"      ,func,realptr,sfLN)     ;  /* ln        */
     enterstdpf_sub("arctan"  ,func,realptr,sfARCTAN) ;  /* arctan    */
}

/****************************************************/
/*  enterdtdpf_sub() : W葱֐̓o^Tu  */
/****************************************************/
static void enterstdpf_sub(char *name,enum idclass pf,
                           stp *typeptr,stdpf pfid)
{
  ctp *cp ;

     cp = mkctp(name,pf,typeptr,nil);   /* OGAmۂ       */
     cp->n.pf.pfdeckind = standard    ; /* W֐                   */
     cp->n.pf.sd.key    = pfid        ; /* ʎq                     */
     enterid(cp)                      ; /* Oo^                   */
}
